;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                 CHK_DATE.ASM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Author: Robert Ree  1993
;
; Downloaded from:
;      Professional Programmers' Pages
;      http://www.fys.ruu.nl/~faber
; for all your Assembly and Visual Basic info
;
; Please give some credit to the author if
; you use any of the code below !
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CHK_DATE.ASM
;assemble and link as CHK_DATE.COM
;Checks today's system date and generates errorlevel code of 1
;if date has changed since CHK_DATE.COM was last run.
;Date is saved in file called "CHK_DATE.SAV" in directory
;that CHK_DATE.COM was called from.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.model tiny
; added by Jannes Faber (May 4th 1995) because it assembled into an EXE file
; by default (used MASM 6.0).

code          segment para public 'CODE'    ;
              assume cs:code, ds:code, es:code;
              org 100h                      ;
start:        jmp  start_prog               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
programmer    db   "Robert Ree, 1993"       ;
f_name        db   "CHK_DATE.SAV",0         ;
f_handle      dw   ?                        ;
date_today    db   20 dup (0)               ;
date_saved    db   20 dup (0)               ;
exit_code     db   0                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_prog:   mov  ah,2ah                   ;get current date
              int  21h                      ;
              push cx                       ;year on the stack

;convert date to ascii string and store in buffer at offset "date_today"

              mov  di,offset date_today     ;

              mov  al,dh                    ;month in dh
              xor  ah,ah                    ;
              call convert                  ;
              mov  al,'-'                   ;insert a "-"  in string
              stosb                         ;

              mov  al,dl                    ;date nr in dl
              xor  ah,ah                    ;
              call convert                  ;convert day to ascii
              mov  al,'-'                   ;insert - in string
              stosb                         ;

              pop   cx                      ;retrieve year no.
              mov   ax,cx                   ;
              mov   bl,64h                  ;
              div   bl                      ;
              call  convert                 ;convert to ascii
              mov   al,ah                   ;
              call  convert                 ;convert to ascii

;open file to read saved date

open_file:    mov  ah,3dh                   ;open file
              mov  al,2                     ;read\write
              mov  dx,offset f_name         ;
              int  21h                      ;dos function
              jnc  file_found               ;no carry, so ...

;create new file if none found

              mov  ah,3ch                   ;no file found, try create one ...
              xor  cx,cx                    ;regular attrib
              int  21h                      ;dos function
              mov  [f_handle],ax            ;our file handle
              jnc  save_date                ;
              jmp  prog_xit                 ;quit now if a problem

file_found:   mov  [f_handle],ax            ;save file handle
              mov  bx,ax                    ;our data file handle
              mov  cx,10                    ;pull record at file ptr
              mov  dx,offset date_saved     ;point to the buffer
              mov  ah,3fh                   ;dos read file service
              int  21h                      ;

              mov  ax,4200h                 ;reset file pointer
              mov  bx,[f_handle]            ;
              mov  cx,0                     ;to start of file
              mov  dx,0                     ;
              int  21h                      ;

              mov  si,offset date_today     ;poin to today's date
              mov  di,offset date_saved     ;and the date that was saved
              mov  cx,11                    ;only search eleven chars
              call find_match               ;call search procedure
              jnc  close_file               ;if CF=0 date not changed so
                                            ;skip next
;date is changed, so set errorlevel code

              mov  [exit_code],1            ;store errorlevel code

save_date:    mov  ah,40h                   ;write new date back to file
              mov  bx,[f_handle]            ;
              mov  cx,10                    ;
              mov  dx,offset date_today     ;point to the date
              int  21h                      ;dos does it

close_file:   mov  bx,[f_handle]            ;load file handle
              mov  ah,3eh                   ;close file function
              int  21h                      ;dos does it

prog_xit:     mov  al,[exit_code]           ;load errorlevel code
              mov  ah,4ch                   ;exit to dos
              int  21h                      ;all done!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
find_match:   mov  bx,si                    ;point to char to match
              mov  al,[bx]                  ;get one byte
              cmp  al,es:[di]               ;does this byte match?
              jz   next_char                ;check successive bytes
              inc  di                       ;advance record pointer
              dec  cx                       ;decrement counter
              jz   no_match                 ;jump if not found
              jmp  find_match               ;search whole block

next_char:    inc  bx                       ;char matched, advance
              inc  di                       ;both pointers
              dec  cx                       ;
              jz   no_match                 ;run out of string to search
              mov  al,[bx]                  ;and compare next byte
              or   al,0                     ;end of string to match?
              jz   match_fnd                ;yes, we found it

              cmp  al,es:[di]               ;still matching?
              jz   next_char                ;check next character
              jmp  find_match               ;or get the next string

match_fnd:    clc                           ;
              ret                           ;
no_match:     stc                           ;
              ret                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;convert hex to ascii                       ;subroutine to convert a hex value
                                            ;to an ascii value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
convert:      push ax                       ;call with value in AX
              aam                           ;
              add  ax,3030h                 ;
              mov  bl,al                    ;
              mov  al,ah                    ;
              stosb                         ;di points to our buffer
              mov  al,bl                    ;
              stosb                         ;
              pop  ax                       ;
              ret                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
code          ends                          ;
end           start                         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
